# Installation procedure ripped from GRUF 
# my thanks goes to PJ Grizel

from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Acquisition import aq_base

from Products.PloneCASLogin import install_globals
from Products.PloneCASLogin.PloneCASLoginTool import PloneCASLoginTool

SKIN_NAME='PloneCASLogin'
LOGIN_PORTLET='here/portlet_login/macros/portlet'

def install(self):
    out = StringIO()
    print >>out, "Installing PloneCASLogin"
    install_subskin(self, out)
    install_portlet(self, out)
    install_tool(self,out)
    install_cas_auth_helper(self,out)
    print >>out, "Done."
    return out.getvalue()

def install_subskin(self, out, skin_name=SKIN_NAME, globals=install_globals):
    print >>out, "  Installing subskin."
    skinstool=getToolByName(self, 'portal_skins')
    if skin_name not in skinstool.objectIds():
        print >>out, "    Adding directory view for PloneCASLogin"
        addDirectoryViews(skinstool, 'skins', globals)

    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName)
        path = [i.strip() for i in  path.split(',')]
        try:
            if skin_name not in path:
                path.insert(path.index('custom') +1, skin_name)
        except ValueError:
            if skin_name not in path:
                path.append(skin_name)

        path = ','.join(path)
        skinstool.addSkinSelection( skinName, path)
    print >>out, "  Done installing subskin."

def install_portlet(self, out):
    # install login portlet
    # this is redundant with Plone std install, but we want to
    # be sure that this product is usable by dummies

    print >>out, "  Installing or reinstalling login portlet : " + LOGIN_PORTLET
    portal_url = getToolByName(self, 'portal_url')
    portal = portal_url.getPortalObject()
    left_slots = portal.getProperty('left_slots', ())
    if not LOGIN_PORTLET in left_slots:
	left_slots = left_slots + (LOGIN_PORTLET,)
    if not portal.hasProperty('left_slots'):
	portal._setProperty('left_slots', left_slots, 'lines')
    else:
	portal._updateProperty('left_slots', left_slots)
    print >>out, "  Done installing portlet."

def install_tool(self, out):
    print >>out, "  Installing PloneCASLogin Tool "
    portal_url = getToolByName(self, 'portal_url')
    portal = portal_url.getPortalObject()
    if not hasattr(self, PloneCASLoginTool.id):
	portal.manage_addProduct['PloneCASLogin'].manage_addTool('PloneCASLogin Tool', None)
    print >>out, "  Done PloneCASLogin Tool."


def install_cas_auth_helper(self, out):
    try:
	import Products.PluggableAuthService
    except:
        print >>out, "  **********************************************"
        print >>out, "  **** PluggableAuthService is not installed ***"
        print >>out, "  **********************************************"
	raise
    try:
	import Products.CAS4PAS
    except:
        print >>out, "  *********************************"
        print >>out, "  **** CAS4PAS is not installed ***"
        print >>out, "  *********************************"
	raise
    print >>out, "  Installing CAS4PAS Auth Helper "
    portal_url = getToolByName(self, 'portal_url')
    portal = portal_url.getPortalObject()
    cas_auth_helpers = portal.acl_users.objectValues(['CAS Auth Helper'])
    if cas_auth_helpers:
        print >>out, "  ** ABORT ** CAS4PAS Auth Helper Install, there is already one."
        return
    portal.acl_users.manage_addProduct['CAS4PAS'].addCASAuthHelper(id='plonecaslogin', title='PloneCASLogin Installation')
    portal.acl_users.plonecaslogin.manage_activateInterfaces(['IAuthenticationPlugin', 'IChallengePlugin', 'ICredentialsResetPlugin', 'IExtractionPlugin'])
    print >>out, "  Done Installing CAS4PAS Auth Helper."
    print >>out, "    => Do not forget to configure CAS4PAS Auth Helper."



