
# Zope
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from OFS.SimpleItem import SimpleItem

# CMF
from Products.CMFCore.permissions import View
from Products.CMFCore.utils import UniqueObject


class PloneCASLoginTool(UniqueObject, SimpleItem):
    """ PloneCASLogin Tool for accessing CAS Login URL
	Note:
	  CAS Login URL should be considered in public visibility
	  area, so the method provided here is not a security concern.
    """

    __implements__ = ()

    id = 'portal_cas_login'
    meta_type = 'PloneCASLogin Tool'
    _actions = ()

    security = ClassSecurityInfo()
    security.declareObjectProtected(View)

    security.declarePublic('getLoginURL')
    def getLoginURL(self):
	"""
	Returns CAS Login URL from the 1st CAS4PAS Auth Helper found
	Returns None if nothing is found
	"""
	portal = self.getParentNode()
	cas_auth_helpers = portal.acl_users.objectValues(['CAS Auth Helper'])
	if cas_auth_helpers:
	    return cas_auth_helpers[0].getLoginURL()
	else:
	    return None

InitializeClass(PloneCASLoginTool)

